<?php

/**
* Plugin Name: Bima Fonctions
* Plugin URI: https://bima.re/creation/bimafonctions/
* Description: Module wordpress créé par Bima.RE Services avec le shortcode polylang [lang-switch] / un transfert automatique de tous les 404 vers la homepage / la suppression de la barre d'admin pour les non admin et redirection [redirect url='https://www.url.destination' sec='nbdesecondes']
* Author: Patrice Bima (Bima.RE Informatique et services)
* Version: 0.3
* Author URI: https://bima.re/
*/

//La page des options

function enregistre_options() { //étape2 déclarer la fonction de l'action "activer/désactiver le callback"
	register_setting('groupe_options','opt_redir'); //étape3 donne le nom de l'option qui fera partie du groupe d'options et qui activera ou désactivera notre callback
}

add_action('admin_init','enregistre_options'); //étape 1 initialise le fait qu'il va y avoir des options pour notre callback


//La page des options

/*--* Début toutes les fonctions *--*/

/* polylang shortcode [lang-switch] */
function polylang_shortcode() {
	ob_start();
	pll_the_languages(array('show_flags'=>1,'show_names'=>0));
	$flags = ob_get_clean();
	return $flags;
}
add_shortcode( 'lang-switch', 'polylang_shortcode' );

/* Rediriger toutes les erreurs 404 vers la homepage */

add_action('init','change_redir'); //ajoute l'action de changer la valeur de redirection

function change_redir(){

	$option = get_option('opt_redir');

		if($option == "yes"){

		//rediriger
		if( !function_exists('redirect_404_to_homepage') ){

			add_action( 'template_redirect', 'redirect_404_to_homepage' );

			function redirect_404_to_homepage(){
			if(is_404()):
					wp_safe_redirect( home_url('/') );
					exit;
				endif;
			}
		}
		//rediriger

		}

}


/* Supprimer la barre d'admin pour les non-admin */
add_action('after_setup_theme', 'remove_admin_bar');
function remove_admin_bar() {
if (!current_user_can('administrator') && !is_admin()) {
  show_admin_bar(false);
}
}

/* Redirection apres un certain temps [redirect url='https://www.url.destination' sec='nbdesecondes'] */

		add_shortcode('redirect', 'scr_do_redirect');
		function scr_do_redirect($atts)
		{
			ob_start();
			$myURL = (isset($atts['url']) && !empty($atts['url']))?esc_url($atts['url']):"";
			$mySEC = (isset($atts['sec']) && !empty($atts['sec']))?esc_attr($atts['sec']):"0";
			if(!empty($myURL))
		  {
		?>
				<meta http-equiv="refresh" content="<?php echo $mySEC; ?>; url=<?php echo $myURL; ?>">
				<a href="<?php echo $myURL; ?>">Dans 10 secondes vous allez être redirigé vers la page d'accueil ou cliquez-ici pour y aller plus vite!</a>
		<?php
			}
			return ob_get_clean();
		}

/*--* Fin toutes les fonctions *--*/

/*--* Début Page option *--*/

/* Ajoute une page d'option ne pas modifier */
add_action( 'admin_menu', 'bima_fonctions' );

/* Création de la page option */
function bima_fonctions() {
	add_options_page( 'Bima Fonctions', 'Bima Fonctions', 'manage_options', 'bima-fonctions-identifier', 'bima_options' );
}

/* Accès permission et le wrapper qui intègre les options et variables */
function bima_options(){
	if ( !current_user_can( 'manage_options' ) )  {
		wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
	}
	?>
	
	<div class="wrap">
		<h2>Bima Fonctions</h2>
		<p>Retrouvez nous sur notre site internet <a href="https://bima.re/" target="blank">Bima.re</a></p>
			<p>Le module <strong>Bima Fonctions</strong> permet d'ajouter des options à votre site internet.</p>
			<h4><a href="https://bima.re/creation/bimafonctions/" target="blank">Cliquez-ici pour faire un don!</a></h4>
		<hr>
		<h3>1. Shortcode [lang-switch]</h3>
		<p>Le shortcode <strong>[lang-switch]</strong> permet d'ajouter une sélection de langue à votre site internet via le module <strong>Polylang</strong> à installer au préalable.</p>
		<h3>2. Redirection de toutes les erreurs 404 de votre site vers la homepage</h3>
		<p>Votre site est régulièrement indexé par les moteurs de recherche, lors de la création de votre site, certaines pages changent de nom ou peuvent devenir inexistantes. Ce module va rediriger automatiquement toutes les requêtes devenues inexistantes vers votre page de garde au lieu de produire une erreur 404.</p>
		<form action="options.php" method="post">
			<?php
			settings_fields('groupe_options'); //étape6 déclaration des champs d'options
			?>
				<input id="desactive-redir" type="checkbox" name="opt_redir" value="yes" <?php checked( get_option('opt_redir'),'yes' ) ?> > <!--formulaire d'entrée de la valeur de l'option ici une checkbox qui va influer sur opt_redir qui stocke la valeur -->
				<label for="desactive-redir">Activer la redirection des erreurs 404 vers la homepage?</label> <!--label pour l'option-->

				<?php submit_button('Sauvegarder'); ?>
		</form>
		<h3>3. Supprimer la barre d'admin pour les non-admin</h3>
		<p>Les utilisateurs du site ne devraient pas voir la barre d'édition du site.</p>
		<h3>4. Redirection vers la page de garde après un certain temps</h3>
		<p>Coller le shortcode dans une page pour provoquer la redirection vers l'url de destination apres un certain temps <strong>[redirect url='https://www.url.destination' sec='nbdesecondes']</strong>.</p>

	</div>

	<?php
}

/*--* Fin page option *--*/

?>
